/* Copyright (C) 2022 Brigham Keys, Esq.
 * This file is part of Zombie Shootoff
 *
 * Zombie Shootoff is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Zombie Shootoff is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with thissoftware.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "Global.hpp"
#include <irrlicht.h>

namespace Global {
irr::IrrlichtDevice *device;
irr::video::IVideoDriver *driver;
irr::scene::ISceneManager *smgr;
irr::gui::IGUIEnvironment *guienv;
} // namespace Global

namespace Global::Init {
bool initializeIrrlicht() {
    Global::device = irr::createDevice(irr::video::EDT_SOFTWARE,
                                       irr::core::dimension2d<unsigned int>(640, 480),
                                       16,
                                       false,
                                       false,
                                       true,
                                       0);

    if (not Global::device) {
        return true;
  }
  Global::device->setWindowCaption(L"Zombie Shooter");

  Global::driver = Global::device->getVideoDriver();
  Global::smgr = Global::device->getSceneManager();
  Global::guienv = Global::device->getGUIEnvironment();
  return false;
}
} // namespace Global::Init
